/* Nessus
 * Copyright (C) 1998 Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This is the Authentification Manager
 *
 * This authentification scheme is BADLY written, and should NOT
 * be used in the future
 */


#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdlib.h>
#include <stdio.h> 
#include <stdarg.h>
#include <fcntl.h>
#ifdef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */
#include <sys/types.h>
#include <sys/socket.h> 
#include <signal.h>
#ifdef HAVE_SSL
#include <ssl.h>
#endif  

#include "comm.h"
#include "auth.h"
#include "sighand.h"

extern int global_socket;
   


/* 
 * auth_login
 *
 * sends the login and password to the Nessus 
 * daemon
 *
 * Params :
 *  user : login
 *  password : password
 *
 * Returns :
 *  0 if the login informations were sent successfully
 * -1 if a problem occured
 * 
 * Note : this function does NOT check if the login/password are
 * valid.
 */
int auth_login(user,password)
	char * user;
	char * password;
{
  char * buf = emalloc(255);
  
  auth_gets(buf, 8);
  if(strncmp(buf, "User : ", strlen(buf)))return(-1);
  auth_printf("%s\n", user);
  
  bzero(buf, 255);
  auth_gets(buf,12);
  if(strncmp(buf, "Password : ", strlen(buf)))return(-1);
  auth_printf("%s\n", password);
  efree(&buf);
  return(0);
}

/*
 * auth_printf
 * 
 * This function sends a string to the server.
 * In the future, it will have to encrypt the string
 * but I have not implemented this feature right now
 */
void auth_printf(char * data, ...)
{
  va_list param;
  char * buffer;
  signal(SIGPIPE, sighand_pipe);
  va_start(param, data);
  buffer = emalloc(4096);
#ifdef HAVE_VNSPRINTF
  vsnprintf(buffer, 4095, data, param);
#else
  vsprintf(buffer, data,param);
#endif
  send(global_socket, buffer, strlen(buffer), 0);
  efree(&buffer);
  signal(SIGPIPE, SIG_IGN);
  va_end(param);
}                    

/*
 * auth_gets
 * 
 * Reads data sent by the server, and will
 * have to decrypt it in the future
 */
char * auth_gets(s, size)
     char * s;
     size_t size;
{
  recv_line(global_socket, s, size-1); 
  /* we will have to decrypt some stuff here !*/
  return(s);
}
