/* Nessus
 * Copyright (C) 1998 Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This is the Authentification Manager
 *
 * This authentification scheme is BADLY written, and will NOT
 * be used in the future
 *
 */


#include <config.h>
#include <nessuslib.h>
#include <stdlib.h>
#include <stdio.h> 
#include <stdarg.h>
#include <fcntl.h>
#ifdef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */
#include <sys/types.h>
#include <sys/socket.h> 
#include <signal.h>
#include <time.h>
#include <sys/time.h>
#include <unistd.h>

#include "comm.h"
#include "auth.h"
#include "log.h"
#include "sighand.h"

/* 
 * Global variable
 */
extern int global_socket;


/*
 * auth_check_user() :
 *
 * Checks if a user has the right to use nessusd,
 * and return its permissions
 */
char * 
auth_check_user(usersdb, from)
   struct users * usersdb;
   char * from;
{
  char * buf_user, * buf_password;
  char * permissions;
  
  buf_user = emalloc(255);
  buf_password = emalloc(255);
  
  auth_printf("User : ");
  auth_gets(buf_user, 254);
  
  auth_printf("Password : ");
  auth_gets(buf_password, 254);
  
  buf_user[strlen(buf_user)-1]=0;
  buf_password[strlen(buf_password)-1]=0;
  
  if((permissions = check_user(usersdb, buf_user, buf_password)))
    log_write("successful login of %s from %s\n", buf_user, from);
  efree(&buf_user);
  efree(&buf_password);
  return(permissions);
}

/*
 * auth_printf()
 *
 * Writes data to the global socket of the thread
 */
void 
auth_printf(char * data, ...)
{
  va_list param;
  char * buffer;
  signal(SIGPIPE, sighand_pipe);
  buffer = emalloc(4096);
  va_start(param, data);
#ifdef HAVE_VSNPRINTF
  vsnprintf(buffer, 4095, data, param);
#else
  vsprintf(buffer, data,param);
#endif
  send(global_socket, buffer, strlen(buffer), 0);
  efree(&buffer);
  signal(SIGPIPE, SIG_IGN);
  va_end(param);
}                    


/*
 * auth_gets()
 *
 * Reads data from the global socket of the thread
 */
char * 
auth_gets(s,size)
     char * s;
     int size;
{
  bzero(s, size);
  signal(SIGPIPE, sighand_pipe);
  recv_line(global_socket, s, size);
  if(!strlen(s)){
    log_write("connection closed by the client");
    log_write("exiting");
    exit(0);
  }
  /* we will have to decypher some stuff here !*/
  signal(SIGALRM, SIG_IGN);
  signal(SIGPIPE, SIG_IGN);
  alarm(0);
  return(s);
}

