/* Nessus
 * Copyright (C) 1998 Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Nessus Communication Manager -- it manages the NTP Protocol, version 1.0
 *
 */ 
#include <config.h>
#include <nessuslib.h>
#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_STRING_H
#include <string.h>
#endif
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif
#include <sys/socket.h>
#include "ntp.h"
#include "comm.h"

extern int global_socket;
int ntp_10_parse_input(input, preferences)
 char * input;
 struct arglist * preferences;
{
 char * strs[8];
 int good = 0;
 int i;

 
 for(i=0;i<8;i++)strs[i] = emalloc(strlen(input)+1);
 sscanf(input, "%s <|> %s <|> %s <|> %s <|> %s  <|> %s <|> %s <|> %s",
	     strs[0],strs[1],strs[2],strs[3],strs[4],strs[5],strs[6],strs[7]);
             
 if(!strncmp(strs[1], "QUIT", 4)){
        for(i=0;i<8;i++)efree(&strs[i]);
    	shutdown(global_socket,2);
    	exit(0);
      }
  if(!strncmp(strs[0], "CLIENT", 6) && !strncmp(strs[1],"NEW_ATTACK",10) &&
	 !strncmp(strs[7], "CLIENT", 6))good = 1;
   if(good)
   {
    char * hostname;
    char * port_range;
    
    int max_hosts = atoi(strs[3]);
    if(arg_get_value(preferences, "MAX_HOSTS"))
     arg_set_value(preferences, "MAX_HOSTS", sizeof(int), (void *)max_hosts);
    else
     arg_add_value(preferences, "MAX_HOSTS", ARG_INT, sizeof(int), (void *)max_hosts);
    
    comm_setup_plugins(strs[2]);
    hostname = emalloc(strlen(strs[6])+1);
    strncpy(hostname, strs[6], strlen(strs[6]));
    
    if(arg_get_value(preferences, "TARGET"))
     arg_set_value(preferences, "TARGET", strlen(hostname), hostname);
    else
     arg_add_value(preferences, "TARGET", ARG_STRING, strlen(hostname), hostname);
     
    port_range = emalloc(strlen(strs[5])+1);
    strncpy(port_range, strs[5], strlen(strs[5]));
    if(arg_get_value(preferences, "PORT_RANGE"))
     arg_set_value(preferences, "PORT_RANGE", strlen(port_range), port_range);
    else
     arg_add_value(preferences, "PORT_RANGE", ARG_STRING, strlen(port_range), port_range);
    }
   for(i=0;i<8;i++)efree(&strs[i]);
   return(!good);
}
  
  
 
