/* Nessus
 * Copyright (C) 1998 Renaud Deraison
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Signals handler
 */

#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <signal.h>
#ifdef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif /* HAVE_STRINGS_H */    
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/ioctl.h> 
#include "log.h"
#include "auth.h"
#include "threads.h"
#include "sighand.h"
extern int global_socket;
extern struct nessusd_threads *threads;
void sighand_pipe()
{
  log_write("connection closed by the client (SIGPIPE caught)\n");
  shutdown(0,2);
  close(0);
  _exit(1);   
}

void sighand_chld()
{
  wait(NULL);
}


void sighand_alarm()
{
  log_write("connection timed out\n");
  shutdown(0,2);
  close(0);
  _exit(1);
}           

void sighand_alarm_plugin()
{
 extern pid_t current_plugin;
#ifdef LOGMORE
 log_write("current plugin is slow to finish -- sending SIGKILL\n");
#endif
 kill(current_plugin, SIGKILL);
}


void sighand_term()
{
  log_write("received the TERM signal\n");
#ifndef USE_AF_INET
  unlink(AF_UNIX_PATH);
#endif
  exit(0);
}
 
void sighand_int()
{
 log_write("received the INT signal\n");
#ifndef USE_AF_INET
 unlink(AF_UNIX_PATH);
#endif
 exit(0);
}

void sighand_segv()
{
 signal(SIGSEGV, exit);
 log_write("SIGSEGV occured !\n");
#ifndef USE_AF_INET
 unlink(AF_UNIX_PATH);
#endif
 exit(0);
}

void sighand_kill()
{
 log_write("received the KILL signal\n");
#ifndef USE_AF_INET
  unlink(AF_UNIX_PATH);
#endif
  exit(0);
}

void sighand_io()
{
  char * buf;
  char * t;
  int i = 0;
  
  ioctl(global_socket, FIONREAD, &i);
  if(i)
    {
      buf = emalloc(4096);
      auth_gets(buf, 4095);
#ifdef DEBUG
      if(strlen(buf))printf("Received in our async socket : %s\n",buf);
#endif
      if((t = strstr(buf, "STOP_ATTACK")))
	{  
	  char * t2;
	  t2 = strstr(t, "<|> ");
	  if(!t2)return;
	  t2+=strlen("<|> ");
	  t = strstr(t2, " <|>");
	  if(!t)return;
	  t[0] = 0;
	  nessusd_thread_kill_by_name(&threads, threads, t2);
	  t[0] = ' ';
	}
      else if((t = strstr(buf,"STOP_WHOLE_TEST"))){
        log_write("stopping the whole test (requested by client)");
        nessusd_thread_kill_all(threads);
        exit(0);
        }
       
      efree(&buf);
    }
}

